/*--------------------------------------------------------------------.
| qascade.h							      |
| 								      |
| Copyright (c) 1997 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/

/*
 * $Log: qascade.h,v $
 * Revision 1.9  1997/12/07 20:24:59  jrh
 * added fi2 code
 *
 * Revision 1.8  1997/11/30 21:08:25  jrh
 * Added HOT_DO functions
 *
 * Revision 1.7  1997/11/15 14:33:02  jrh
 * reindented for release 1.05
 *
 * Revision 1.6  1997/11/14 22:37:48  jrh
 * optimised reversed menus
 *
 * Revision 1.5  1997/11/13 22:10:46  jrh
 * *** empty log message ***
 *
 * Revision 1.4  1997/10/12 20:41:40  jrh
 * indented source code
 *
 * Revision 1.3  1997/10/05 19:52:37  jrh
 * Enhanced dynamic memory allocations
 *
 * Revision 1.2  1997/10/04 19:55:03  jrh
 * tidied up for release v1.0
 *
 * Revision 1.1  1997/10/02 21:28:33  jrh
 * Initial revision
 *
 */

#define TITLE 1
#define EXEC  2
#define ETHG  3
#define MBAS  4
#define SBAS  5
#define HKEY  6
#define FI2   7
#define SEP   80
#define MENU  100
#define UNEM  200
#define COLS  300
#define JUMP  400

#include "version.h"

/*-----------------------.
| define a 'state table' |
`-----------------------*/

typedef struct
{
    short state;
    char *name;
}
STABLE;

/*---------------------------------.
| Structure to hold menu item info |
`---------------------------------*/

typedef struct
{
    void *ptr;
    short act;
    short len;
    char chrs[1];		/* Will be allocated size as required */
}
MINFO;

/*-------------------------------.
| Define structure for menu item |
`-------------------------------*/

typedef struct _items ITEMS;

struct _items
{
    ITEMS *next;
    MINFO *l;
};

/*--------------------------------------------------------------.
| Define structure for a  menu (as parsed, not what QPTR needs) |
`--------------------------------------------------------------*/

typedef struct
{
    char *title;
    short width;
    short height;
    ITEMS *items;
}
MENUS;

/*--------------------------.
| Some odd functions we use |
`--------------------------*/

extern void *xalloc (int);
extern void xfree (void *);
extern int menu (WM_wwork_t *, MENUS *, void **);
extern int io_open3 (char *, int, int);
extern int TryThing (char *thing, char *cmd, short timo, void **pt,
		     int nfn,...);
extern int fork (char *, char *);
extern void vStartMBJob (char *, char *, char *, int, int,...);
extern void StartMBJob (char *, char *, char *, int, int, char **);
extern short menu_text (WM_wwork_t *, char *, char *, int);
extern int menu_choice (WM_wwork_t *, char *, int, int,...);
extern void BurnMe(char *);
extern int fi2exec (char *, int);

extern unsigned char colarray[13];

#define COLBORD  0
#define COLPAPR  1
#define COLPSAC  2
#define COLPSBC  3
#define COLPSCC  4
#define COLCURC  5
#define COLUBACK 6
#define COLUINK  7
#define COLABACK 8
#define COLAINK  9
#define COLSBACK 10
#define COLSINK  11
#define MAXCOL   12
